\chapter{ASPN} %codeword: aspn
\label{ch:aspn}

In which one examines Newton-Raphson preconditioned by alternating Schwarz as a means to discuss all methods in this family;
discusses cycling behaviour in fixed point iterations, Newton and secant methods;
provides a class of counter-examples where this cycling may be seen when applied to ASPN.

\section{Introduction}
\label{aspn sec:intro}

Domain decomposition methods subdivide problems into subproblems.
These subproblems are solved iteratively and information passed between one another until they arrive at a solution.
This iterative process can be slow and so one seeks ways to accelerate it.

Equivalently \cite{Gander2017}, one may consider these domain decomposition methods to be preconditioning some other method such as Newton-Raphson or a Krylov subspace method.
This preconditioning makes the problem easier or faster to solve by splitting it into subproblems, as described above.
ASPIN \cite{Cai2002}, RASPEN \cite{Dolean2016}, and MSPIN \cite{liu2015field} rely on various Schwarz methods to precondition either Newton-Raphson or inexact Newton.

Let us begin by presenting the algorithm for alternating Schwarz, one of the simplest domain decomposition methods.
Suppose we seek to solve the boundary value problem
\begin{equation*}
F(x,u,u',u'')=0, \quad x \in [a,b], \quad u(a)=A, \quad u(b)=B
\end{equation*}
for some function $F(x,u,v,w)$.
The domain $[a,b]$ is split into two parts, $[a,\beta]$ and $[\alpha, b]$ with $\alpha < \beta$.
The problem is solved on each subdomain and boundary data is passed from one subdomain to the other.
One iteration of alternating Schwarz can then be summarized in the following three steps:
\begin{align*}
(1) && & F(x,u_1,u_1',u_1'') = 0, && u_1(a) = A, && u_1(\beta) = \gamma_n, \\
(2) && & F(x,u_2,u_2',u_2'') = 0, && u_2(\alpha) = u_1(\alpha), && u_2(b) = B, \\
(3) && & \gamma_{n+1} = u_2(\beta) = G(\gamma_n).
\end{align*}

The function $G(\gamma)$ thus represents one iteration of alternating Schwarz in substructured form.
It takes as input $\gamma$ the value of $u_1(\beta)$, and returns as output the value of $u_2(\beta)$.
The process is repeated until convergence, ie.
\begin{equation*}
\left ( G \circ G \circ \dots \circ G \right ) (\gamma) = G^n(\gamma) \approx G^{n+1}(\gamma) = \left ( G \circ G^n \right ) (\gamma).
\end{equation*}
This is naturally a fixed point iteration applied to the function $G(\gamma)$.

To accelerate the method one applies Newton-Raphson to the function $f(\gamma) = G(\gamma) - \gamma$, which has a root at the fixed point.
If the fixed point is unique, this is the only root of $f(\gamma)$.
To apply Newton-Raphson, one needs to know the value of $G'(\gamma)$, which may be found by adding two new steps, (1') and (2'), to alternating Schwarz:
\begin{align*}
(1) && F(x,u_1,u_1',u_1'') = 0, && & u_1(a) = A, && u_1(\beta) = \gamma_n, \\
(1') && J(u_1) \cdot (v_1,v_1',v_1'') = 0, && & v_1(a) = 0, && v_1(\beta) = 1, \\
(2) && F(x,u_2,u_2',u_2'') = 0, && & u_2(\alpha) = u_1(\alpha), && u_2(b) = B, \\
(2') && J(u_2) \cdot (v_2,v_2',v_2'') = 0, && & v_2(\alpha) = 1, && v_2(b) = 0, \\
(3) && \gamma_{n+1} = \gamma_n - \frac{ u_2(\beta) - \gamma_n }{v_1(\alpha) v_2(\beta) - 1}= && & \gamma_n - \frac{G(\gamma_n) - \gamma_n}{G'(\gamma_n) - 1},
\end{align*}
where $v_i(x)=\partial u_i(x) / \partial \gamma$ and $J(u_i)$ is the Jacobian of $F(x,u_i,u_i',u_i'')$.

While \textit{a priori} convergence criteria have been found for the underlying Schwarz method, so far none exist for their combination with Newton-Raphson.
We examine cycling behaviour in this accelerated alternating Schwarz method to show the difficulties with finding such criteria.

\section{Convergence of generic fixed point iterations and Newton-Raphson}

A generic fixed point iteration $x_{n+1}=g(x_n)$ converges when $\abs{g(x_n)-x^*} < \abs{x_n-x^*}$, where $x^*$ is the fixed point, as this indicates $g(x_n)$ is closer to $x^*$ than $x_n$.
This occurs when $g(x)$ lies between $x$ and $2x^*-x$.

The convergence or divergence of the fixed point iteration is monotonic if $\sign(g(x)-x^*) = \sign(x - x^*)$.
In this case $g(x)$ and $x$ lie on the same side of $x^*$.
If this is not the case then $g(x)$ finds itself on the opposite side of the fixed point and so oscillates.

This creates four lines, $y=x$, $y=2x^*-x$, $y=x^*$ and $x=x^*$, that divide the plane into octants.
The four pairs of opposite octants form four regions with distinct
behaviour of the fixed point iteration, see left of Figure \ref{aspn fig:FP} or Figure 5.7 from \cite{gander2014scientific}:
\begin{description}
\item[\textcolor{red}{1}, $g(x) < x < x^*$ or $g(x) > x > x^*$:] monotonic divergence;
\item[\textcolor{blue}{2}, $x < g(x) < x^*$ or $x > g(x) > x^*$:] monotonic convergence;
\item[\textcolor{darkgreen}{3}, $x < x^* < g(x) < 2 x^* - x$ or $x > x^* > g(x) > 2 x^* - x$:] convergent oscillations;
\item[\textcolor{orange}{4}, $x < x^* < 2 x^* - x < g(x)$ or $x > x^* > 2 x^* - x > g(x)$:] divergent oscillations.
\end{description}
\begin{figure}
	\centering
        \begin{tikzpicture}
        	\matrix[column sep=1em, row sep=1em, every cell/.style={scale=0.5}]{
            \draw[black,thick,->] (-4,0) -- (4,0) node[above] {$x$};
            \draw[black,thick,->] (0,-4) -- (0,4) node[right] {$g(x)$};
            \draw[black,dashed] (-4,-4) -- (4,4);
            \draw[black,dashed] (-4,4) -- (4,-4);
            
            \filldraw[red,opacity=0.1] (-4,-4) -- (0,-4) -- (0,0) -- cycle; \filldraw[red,opacity=0.1] (4,4) -- (0,4) -- (0,0) -- cycle;
            \filldraw[blue,opacity=0.1] (-4,-4) -- (-4,0) -- (0,0) -- cycle; \filldraw[blue,opacity=0.1] (4,4) -- (4,0) -- (0,0) -- cycle;
            \filldraw[darkgreen,opacity=0.1] (-4,4) -- (-4,0) -- (0,0) -- cycle; \filldraw[darkgreen,opacity=0.1] (4,-4) -- (4,0) -- (0,0) -- cycle;
            \filldraw[orange,opacity=0.1] (-4,4) -- (0,4) -- (0,0) -- cycle; \filldraw[orange,opacity=0.1] (4,-4) -- (0,-4) -- (0,0) -- cycle;
            
            \draw[red,thick,opacity=0.8] plot[smooth] coordinates {(0.25,1) (0,0) (-0.5,-1.5) (-1,-2) (-2,-3) (-2.25,-4)};
            \draw[blue,thick,opacity=0.8] plot[smooth] coordinates {(-3,-2.5) (-2,-1.5) (-1.5,-1) (0,0) (0.5,0.25)};
            \draw[darkgreen,thick,opacity=0.8] plot[smooth] coordinates {(-3,1) (-2,1) (0,0) (1,-0.5) (2.5,-1)};
            \draw[orange,thick,opacity=0.8] plot[smooth] coordinates {(-1.5,3) (-1,2) (0,0) (2,-2.5) (3,-3.5)};
            
            \draw[red,->,thick,dashed] (-1,-2) -- (-2,-2) -- (-2,-3)--(-3,-3)--(-3,-4); % 1
            \filldraw[black] (-1,-2) circle (3pt); \filldraw[black] (-2,-3) circle (3pt);
            \draw[blue,->,thick,dashed] (-2,-1.5) -- (-1.5,-1.5) -- (-1.5,-1)--(-1,-1)--(-1,-0.5); % 2
            \filldraw[black] (-2,-1.5) circle (3pt); \filldraw[black] (-1.5,-1) circle (3pt);
            \draw[darkgreen,->,thick,dashed] (-2,1) -- (1,1) -- (1,-0.5)--(-0.5,-0.5)--(-0.5,0.25); % 3
            \filldraw[black] (-2,1) circle (3pt); \filldraw[black] (1,-0.5) circle (3pt);
            \draw[orange,->,thick,dashed] (-1,2) -- (2,2) -- (2,-2.5)--(-2.5,-2.5)--(-2.5,3); % 4
            \filldraw[black] (-1,2) circle (3pt); \filldraw[black] (2,-2.5) circle (3pt);
            
            \draw (-1,-3) node {1};
            \draw (-3,-1.5) node {2};
            \draw (-3,1.5) node {3};
            \draw (-1,3) node {4};
            \draw(1,3) node {1};
            \draw (3,1.5) node {2};
            \draw (3,-1.5) node {3};
            \draw (1,-3) node {4};
            &
            
            \filldraw[red,opacity=0.1] (-2,4) -- (4,4) -- (4,2) -- (-2,2) -- cycle; \filldraw[red,opacity=0.1] (-2,2) -- (-2,0) -- (-4,0) -- (-4,2) -- cycle;
            \filldraw[blue,opacity=0.1] (-2,4) -- (-4,4) -- (-2,2) -- cycle; \filldraw[blue,opacity=0.1] (-2,2) -- (-2,0) -- (0,0) -- cycle;
            \filldraw[darkgreen,opacity=0.1] (-4,4) -- (-4,3) -- (-2,2) -- cycle; \filldraw[darkgreen,opacity=0.1] (-2,2) -- (2,0) -- (0,0) -- cycle;
            \filldraw[orange,opacity=0.1] (-4,3) -- (-4,2) -- (-2,2) -- cycle; \filldraw[orange,opacity=0.1] (-2,2) -- (2,0) -- (4,0) -- (4,2) -- cycle;
            
                    \draw[black,thick,->] (-4,0) -- (4,0) node[above] {$x$};
                    \draw[black,thick,->] (0,-2) -- (0,4) node[right] {$f(x)$};
                    \filldraw[black] (-2,2) circle (3pt);
                    \draw[blue,thick,opacity=0.8] (0,0) parabola (-2,2) -- (-3,4);
                    \draw[black,dashed] (-4,2) -- (4,2);
                    \draw[black,dashed] (-2,4)--(-2,-1);
                    \draw[black,dashed] (-4,4)--(1,-1);
                    \draw[black,dashed] (-4,3)--(4,-1);
                    \draw[red,->,thick,dashed] (-1.5,2.5) -- (-4,0);
                    \draw[blue,->,thick,dashed] (-2,2) -- (-1,0);
                    \draw[darkgreen,->,thick,dashed] (-2.75,2.5) -- (1,0);
                    \draw[orange,->,thick,dashed] (-2.75,2.25) -- (4,0);
%                    \draw[red,->] (-4,2) -- (4,2); % 4-1
%                    \draw[red,->] (-2,2) -- (-2,0); % 1-2
%                    \draw[red,->] (-2,2) -- (0,0); % 2-3
%                    \draw[red,->] (-2,2) -- (2,0); % 3-4
                    
%                    \filldraw[red,opacity=0.25] (-4,2)--(-2,2)--(-2,0)--(-4,0)--cycle;
%                    \filldraw[blue,opacity=0.25] (-2,2)--(-2,0)--(0,0)--cycle;
%                    \filldraw[purple,opacity=0.25] (-2,2)--(0,0)--(2,0)--cycle;
%                    \filldraw[orange,opacity=0.25] (-2,2)--(2,0)--(4,0)--(4,2)--cycle;
                    
                    \draw (-1.25,-0.5) node {2};
                    \draw (-3,-0.5) node {1};
                    \draw (1.5,-0.5) node {3};
                    \draw (3.5,-0.5) node {4};
            \\};
        \end{tikzpicture}
        \caption{\textbf{Left:} Behaviour of the fixed point iteration $x_{n+1}=g(x_n)$, where the origin is the fixed point, $g(0)=0$.
        \textbf{Right:} Regions of Newton-Raphson, $x_{n+1}=x_n - f(x_n)/f'(x_n)$, where the origin is the root, $f(0)=0$.
        The tangent line to $f(x)$ can be traced from $(x,f(x))$ towards the line $y=0$.
        Where it lands on this line indicates which fixed point iteration behaviour occurs.}
        \label{aspn fig:FP}
\end{figure}

If the function $g(x)$ intersects the line $y=x$ at a point other than $x^*$ then there are additional fixed points that the method can converge towards.
If it intersects the line $y=2x^*-x$ then a stable cycle can form.
A fixed point iteration is therefore only guaranteed to converge if $g(x)$ lies entirely between the lines $y=x$ and $y=2x^*-x$, ie. within regions 2 and 3.

Newton-Raphson can make use of this analysis by considering it as a fixed point iteration:
\begin{equation*}
x_{n+1} = x_n - \frac{f(x_n)}{f'(x_n)} = g_f(x_n).
\end{equation*}
The borders between the regions no longer depend solely on the value of $f(x)$ but also $f'(x)$.
The right of Figure \ref{aspn fig:FP} shows which type of behaviour Newton-Raphson will have based on where the tangent line points.
%\begin{figure}
%\sidecaption[t]
%\includegraphics{TIKZ_cycles_NRRegions_20201223.pdf}
%                \caption{Regions of Newton-Raphson.
%                The tangent line to $f(x)$ can be traced from $(x,f(x))$ towards the line $y=0$.
%                Where it lands on this line indicates which fixed point iteration behaviour occurs.
%                The origin is the root.}
%                \label{aspn fig:NR1}
%\end{figure}

The borders of the regions are summarized in Figure \ref{aspn fig:borders2}.
The slopes of most of these borders are easy to see.
If $f'(x)=0$ then $f(x)$ lies on the border between regions 1 and 4.
If $f'(x)=\infty$ then it is between regions 1 and 2.
If $f(x)$ is linear then it is between regions 2 and 3 and converges instantaneously.

\newcommand{\faxis}{\clip (-4,-4) rectangle (4,4);
		\draw[black,thick,->] (-4,0) -- (4,0);
		\draw[black,thick,->] (0,-4) -- (0,4);}
\newcommand{\gaxis}{\clip (-4,-4) rectangle (4,4);
			\draw[black,thick,->] (-4,-4) -- (4,4);
			\draw[black,thick,->] (0,-4) -- (0,4);}
\begin{figure}
\centering
	\begin{tikzpicture}
	\matrix[column sep=0.5cm, row sep=0.5cm, every cell/.style={scale=0.24}]
	{
	\node at (0,-5) {\textbf{(a)}};
	\gaxis
	\foreach \a in {0,1,2,3} {
		\foreach \s in {-1,1} {
			\draw[black,dashed] (\s*\a,-4) -- (\s*\a,4);
			}
		} &
	\node at (0,-5) {\textbf{(b)}};
	\gaxis
	\foreach \a in {0,0.5,1,2,4} {
		\foreach \s in {-1,1} {
			\draw[black,dashed,domain=-4:4,smooth,variable=\x] plot ({\x},{\s*\a*\x + \x});
			}
		} &
	\node at (0,-5) {\textbf{(c)}};
	\gaxis
	\foreach \a in {1,-1,2,-2,0.5,-0.4,1.5,-1.5} {
                    \draw[domain=-4:4, smooth, samples=200, variable=\x, black, dashed] plot ({\x},{\a * sqrt(abs(\x)) + \x});
                    } &
	\node at (0,-5) {\textbf{(d)}};
	\gaxis
           \foreach \a in {0,1,2,3} {
		\foreach \s in {-1,1} {
			\draw[black,dashed,domain=-4:4,smooth,variable=\x] plot({\x},{\x+\s*\a});
			}
		} \\
	};
	\end{tikzpicture}
\caption{Borders between respective regions, traced from tangent lines.
\textbf{(a)} Regions 1 and 2; \textbf{(b)} 2 and 3; \textbf{(c)} 3 and 4; \textbf{(d)} 4 and 1.}
\label{aspn fig:borders2}
\end{figure}

The border between regions 3 and 4 changes depending on the value of $x$.
Recall that this border is represented by $y=2x^*-x$.
As stated, if $g_f(x)$ intersects the line $y=x$ there are additional fixed points, and if it intersects $y=2x^*-x$ there may be stable cycles.
For guaranteed convergence $g_f(x)$ must lie between these lines.
Intersections of $g_f(x)$ with $y=x$ occur only if $f(x)=0$ and $f(x)$ has additional roots or $f'(x)=\infty$.
Both circumstances are assumed not to occur.
Intersections of $g_f(x)$ with $y=2x^*-x$ may be represented as a first order ODE:
\begin{equation*}
f_C'(x) = -\frac{f_C(x)}{2 (x^*- x)}, \quad f_C(x^*) = 0.
\end{equation*}
The solution to this ODE is $f_C(x) = C \sqrt{\abs{x - x^*}}$ where $C \in \bbr$.

If a function $f(x)$ with root $x^*$ is tangential to $f_C(x)$ for any value of $C$ then $g_f(x)$ intersects the line $y=2x^*-x$.
The left of Figure \ref{aspn fig:borders} shows the functions $f_C(x)$.
\begin{figure}
\centering
	\begin{tikzpicture}
	\matrix[column sep=0.5cm, row sep=0.5cm, every cell/.style={scale=0.4}]
	{
	\faxis
	\foreach \a in {1,-1,2,-2,0.5,-0.4,1.5,-1.5} {
                    \draw[domain=-4:4, smooth, samples=200, variable=\x, black, dashed] plot ({\x},{\a * sqrt(abs(\x))});
                    } &
	\gaxis
	\foreach \a in {1,-1,2,-2,0.5,-0.4,1.5,-1.5} {
                    \draw[domain=-4:4, smooth, samples=200, variable=\x, black, dashed] plot ({\x},{\a * sqrt(abs(\x)) + \x});
		} \\
	};
	\end{tikzpicture}
\caption{\textbf{Left:} Solutions $f_C(x)$ such that $g_f(x)$ intersects $y=2x^*-x$ for all $x$.
\textbf{Right:} Functions $g_C(x)=f_C(x)+x$ such that $g_f(x)$ for $f(x)=g_C(x)-x$ intersects $y=2x^*-x$ for all $x$.}
\label{aspn fig:borders}
\end{figure}
A function $f(x)$ that is monotonic with respect to this geometry has guaranteed convergence under Newton-Raphson.
That is, if $f(x)$ is nowhere tangential to $f_C(x)$ in a given domain containing $x^*$ for any value of $C$ then $g_f(x)$ converges to the root for any initial guess in that domain.
Since $f_C'(x^*)=\infty$ and $f(x^*)=0$ there is always a region around the root $x^*$ where $f(x)$ crosses all of these lines monotonically.
This conforms with the theory on Newton-Raphson, which states the method has guaranteed convergence starting sufficiently near the root.

Branin suggests an adjustment to Newton-Raphson \cite{branin1972widely}:
\begin{equation*}
x_{n+1} = x_n - \frac{f(x)}{\abs{f'(x)}} .
\end{equation*}
This naturally assumes that $f(x) > 0$ when $x < x^*$ and $f(x) < 0$ when $x > x^*$.
If the reverse is true, one may apply the method to $-f(x)$.
Using this method requires knowledge of the position of $x^*$ with respect to $x$.
However, if one has this knowledge then this method may overcome many of the pitfalls of Newton-Raphson.
The lines $f_C(x)$ must also incorporate the sign change for this method:
\begin{equation*}
f_C(x) = C \sign(x - x^*) \sqrt{\abs{x-x^*}} .
\end{equation*}

The corresponding geometry for a fixed point function accelerated by Newton-Raphson is skewed such that the line $y=0$ is aligned to $y=x$, as seen in the right of Figure \ref{aspn fig:borders}.
The lines of this figure are the functions $g_C(x) = f_C(x) + x$.
A function $g(x)$ must be monotonic in this geometry or Newton-Raphson applied to $g(x)-x$ may exhibit cycling behaviour.

The slopes of the lines $g_C(x)$ can then indicate necessary and, in some cases, sufficient conditions for Newton-Raphson to converge.
To use these conditions, one must know which fixed point region of the left of Figure \ref{aspn fig:FP} the function $g(x)$ lies.
One can then find the maximum and minimum slope of $g_C(x)$ in those regions.
If $g(x)$ has a slope below these values then Newton-Raphson must converge, thus giving sufficient conditions.
If there is not a minimum then $g'(x)$ must still adhere to the maximum, giving necessary conditions.

\begin{description}
\item[Region 1:] Given that $\sqrt{\abs{x-x^*}}$ is non-negative, $g_C(x) < x$ only if $C < 0$ and $g_C(x) > x$ only if $C > 0$.
Thus, if $g_C(x)$ lies within region 1 then $\sign(C) = \sign(x-x^*)$ and $g_C'(x) >1$.

\item[Region 2:] The lower boundary is already defined by $C=0$ by the above work.
Likewise, by the above work $\sign(C) \neq \sign(x-x^*)$.
Next, one examines where $g_C(x) < x^*$:
\begin{align*}
C < \frac{x^* - x}{\sqrt{\abs{x^*-x}}} = \sign(x^*-x) \sqrt{\abs{x^*-x}} \implies C^2 \begin{cases} < \abs{x^*-x} & x^* > x \\ > \abs{x^*-x} & x^* < x . \end{cases}
\end{align*}
One can also show that $g_C'(x)$ is bounded within this region:
\begin{align*}
g_C'(x) & = 1 + \sign(x-x^*) \frac{C}{2 \sqrt{\abs{x-x^*}}} > 1 + \frac{1}{2} \sign(x-x^*) \sign(C) = \frac{1}{2} , \\
g_C'(x) & < 1 + \sign(x-x^*) \lim_{x \to \pm \infty} \frac{C}{2 \sqrt{\abs{x-x^*}}} = 1 + 0 = 1 , \\
\implies & 1/2 < g_C'(x) < 1 .
\end{align*}

\item[Region 3:] As before, the lower boundary is defined by the previous work.
For the upper boundary, one considers where $g_C(x) < 2x^* - x$:
\begin{align*}
x + C \sqrt{\abs{x-x^*}} < 2 x^* - x & \implies C < \sign(x^*-x) 2 \sqrt{\abs{x^*-x}} \\
& \implies \frac{C^2}{4} \begin{cases} < \abs{x^*-x} & x^* > x \\ > \abs{x^*-x} & x^* < x . \end{cases}
\end{align*}
As in region 2, one can show that $g_C'(x)$ is bounded in region 3:
\begin{equation*}
g_C'(x) > 1 + \sign(x-x^*) \frac{C}{\abs{C}} = 0.
\end{equation*}

\item[Region 4:] No extra work is required for this region.
If $g_C(x)$ is in region 4 then $\sign(C) \neq \sign(x-x^*)$, $\abs{x^* - x} < C^2/4$ and $g_C'(x) < 0$.
\end{description}

For convergence it is necessary that $g(x)$ satisfy the same conditions as $g_C(x)$.
If not, then there exists values of $x$ for which $g(x)$ is parallel to $g_C(x)$ for some value of $C$.
It is also sufficient if $g'(x)<g_C'(x)$ for all possible $C$ in the region which contains $g(x)$.
The list of these necessary and sufficient conditions is summarized in Table \ref{aspn tab:conditions}.
\begin{table}[t]
    \caption{Conditions for convergent behaviour of Newton-Raphson applied to $g(x)-x$.}
\label{aspn tab:conditions}
\centering
    \begin{tabular}{p{2cm}p{4cm}p{4cm}}
\hline\noalign{\smallskip}
        $g(x)$ lies in & Necessary condition & Sufficient condition \\ 
\noalign{\smallskip}\hline\noalign{\smallskip}
        1 & $g'(x) >1$ \\
        2 & $g'(x) < 1$ & $g'(x) < 1/2$ \\
        3 & $g'(x) < 1/2$ & $g'(x) < 0$ \\
        4 & $g'(x) < 0$
    \end{tabular}
\end{table}

\subsection{Convergence of Newton-Raphson in higher dimensions}

Newton's method may be generalized to higher dimensions by replacing the derivative term with the Jacobian or total derivative, denoted here by $J_f(x)$.
For $f(x)$ a vector field ($f:\bbr^n \to \bbr^n$) $J_f(x)$ is a matrix (of size $n \times n$).
\begin{equation} \label{eq:NRgen}
	x_{n+1} = x_n - J_f(x_n)^{-1} f(x_n)
\end{equation}

One is concerned with when $\norm{x_{n+1} - x^*} < \norm{x_n - x^*}$, as this is where the method converges unconditionally.
Divergence occurs when the reverse inequality is true.
Equality is then the boundary between these regions, as in the 1D case.
As was done there we search for an equation that governs when such an equality occurs.

Any vector with the same norm as $x_n - x^*$ is a rotation of $x_n - x^*$ around the origin.
Thus, if $R$ is a rotation matrix ($R^\top R = I$) then
\begin{align*}
	x_{n+1} - x^* & = x_n - x^* - J_f(x_n)^{-1} f(x_n) \\
				  & = R ( x_n - x^* ).
\end{align*}
Simplifying and isolating for $f(x_n)$ we arrive at:
\begin{equation} \label{eq:NRgov}
f(x_n) = J_f(x_n) (I - R) (x_n - x^*).
\end{equation}
If $f$ satisfies this equation for a point $x_n \in \bbr^n$ then that point is on the boundary between convergence and divergence.
The existence of such a boundary permits (but does not guarantee) the existence of cycles.
The closest boundary of this nature to the fixed point is necessarily unstable.
A second boundary beyond the first may be either stable or unstable.

The equation is not readily solvable for general rotations.
However, for $R = -I$ (the antipodal rotation) one can extend the result from 1D to higher dimensions.
That is, the vector field:
\begin{equation*}
	f(x) = \begin{bmatrix}
	\sqrt{\abs{x_1}} \\ \vdots \\ \sqrt{\abs{x_n}}
	\end{bmatrix}
\end{equation*}
is one possible solution for $R = -I$.

Note that any particular solution immediately defines a family of solutions.
Let $f(x)$ be a solution to the governing equation \ref{eq:NRgov}.
Then $A f(x)$ for any matrix $A \in \bbr^{n \times n}$ is also a solution:
\begin{equation*}
	J_{Af}(x_n) = A J_f(x_n) \implies Af(x_n) = J_{Af}(x_n) (I-R) (x_n - x^*).
\end{equation*}

\section{The fixed point iteration of alternating Schwarz}

We now seek to apply this theory to alternating Schwarz.
As stated earlier, we consider alternating Schwarz as a function $G(\gamma)$, taking as input the value of $u_1(\beta)$ and as output the value of $u_2(\beta)$.
Under reasonable conditions we can prove a number of useful properties of $G(\gamma)$ without prior knowledge of the fixed point $\gamma^*$.

\begin{theorem} \label{aspn thm:mono}
If the problem
$F(x,u,u',u'') = 0$ for $x \in \Omega$, $u(x) = h(x)$ for $x \in \partial \Omega$
has a unique solution on $\Omega = [a,\alpha]$ and $\Omega = [\beta,b]$ and the continuations of these solutions are also unique, then the function $G(\gamma)$ is strictly monotonic.
\end{theorem}

\begin{proof}
It suffices to show that $G(\gamma_1) = G(\gamma_2)$ implies $\gamma_1 = \gamma_2$.
Let $u^j_1$ solve the problem on $[a,\beta]$ with $u^j_1(\beta) = \gamma_j$.
Likewise, $u^j_2$ solves the problem on $[\alpha, b]$ with $u^j_2(\alpha) = u^j_1(\alpha)$.
Suppose $u^1_2(\beta) = u^2_2(\beta)$.
Then both $u^1_2$ and $u^2_2$ solve the same problem on $[\beta,b]$.
By assumption, this must mean $u^1_2 = u^2_2$ and $u^1_1(\alpha) = u^2_1(\alpha)$.
By a similar argument, this implies $u^1_1$ and $u^2_1$ solve the same problem on $[a,\alpha]$.
Again by assumption $u^1_1 = u^2_1$ and $\gamma_1 = \gamma_2$.
\end{proof}

We can even prove that $G(\gamma)$ is restricted to region 2 with additional properties.
As an example, we reprove a result from Lui \cite{lui1999schwarz}.

\begin{theorem}[Theorem 2 from \cite{lui1999schwarz}] \label{aspn thm:lui}
Consider the equation
$u''(x) + f(x,u,u') = 0$ for $x \in (a,b)$, $u(a) = u(b) = 0$
under the assumptions that
\begin{itemize}
\item $f \in C^1 \left ( [a,b] \times \mathbb{R} \times \mathbb{R} \right )$ ,
\item $\pdxdy{f(x,v,v')}{u} \leq 0$ for all $x \in [a,b]$ and $v \in H_0^1([a,b])$ ,
\item $\abs{f(x,v,v')} \leq C(1 + \abs{v'}^\eta)$ for all $x \in [a,b]$ and $v \in H_0^1([a,b])$ and some $C > 0$, $0 < \eta < 1$ .
\end{itemize}
The problem is solved using alternating Schwarz with two subdomains and Dirichlet transmission conditions.
Then $G(\gamma)$ for this problem lies within region 2.
\end{theorem}

\begin{proof}
It suffices to prove that the problem is well posed and $0 < G'(\gamma) < 1$ for all $\gamma \in \mathbb{R}$.
The well-posedness of the problem is guaranteed by Proposition 2 from \cite{lui1999schwarz}.
As Lui points out, this also means the problem is well posed on any subdomain.
Using Theorem \ref{aspn thm:mono} this gives monotonicity of $G(\gamma)$.
Moreover, if $u(x)=0$ for any $x \in (a,b)$ then the problem would be well posed on the domains $[a,x]$ and $[x,b]$.
As such, $u(x)$ has the same sign as $\gamma$ and $G'(\gamma) > 0$.

Consider the problem in $g_1$:
\begin{equation*}
g_1''(x) + \pdxdy{f}{u} g_1 + \pdxdy{f}{u'} g_1' = 0, \quad x \in [a,\beta], \quad g_1(a) = 0, \quad g_1(\beta) = 1.
\end{equation*}
From the second assumption on $f$ the operator on $g_1$ satisfies a maximum principle (see, for example, \cite{lui1999schwarz}).
Therefore, $g_1(x) < 1$ for all $x \in (a,\beta)$.
By the same reasoning, $g_2(x) < g_1(\alpha) < 1$ for all $x \in (\alpha, b)$ and $G'(\gamma) < 1$.
Incidentally, the same maximum principle applies for the operator on $-g_1$ and $-g_2$, and so $G'(\gamma) > 0$ as we had before.
\end{proof}

This provides guaranteed convergence of alternating Schwarz.
However, it does not guarantee the convergence when one accelerates it through Newton-Raphson.
Using Table \ref{aspn tab:conditions} we know that such convergence is assured if $G'(\gamma) < 1/2$ for all $\gamma$, but this is not true in all cases and cannot be determined \textit{a priori}.

Take as an example the following second order nonlinear differential equation
\begin{equation} \label{aspn eq:sin}
u''(x) - \sin(\mu u(x)) = 0, \quad x \in (-1,1),
\end{equation}
with homogeneous Dirichlet boundary conditions.
The problem is well posed and admits only the trivial solution $u(x)=0$.
It is easy to see that this equation satisfies the conditions of Theorem \ref{aspn thm:lui}.
Therefore, the alternating Schwarz fixed point iteration, $G(\gamma)$, lies within region 2 and is guaranteed to converge to the fixed point.
Sadly, its Newton-Raphson acceleration will not do so for all initial conditions.
Take $\mu=3.6$ with an overlap of 0.4 and symmetric regions.
\begin{figure}[t]
\centering
\includegraphics[height=0.3\textwidth]{FIG_ASPN/MTLB_1Dsin_NewtonGamma_v1_20210208.eps}
\hspace{1em}
\includegraphics[height=0.3\textwidth]{FIG_ASPN/exp9_02.eps}
\caption{
\textbf{Left:} Results of Newton-Raphson accelerated alternating Schwarz as a function of initial condition in solving equation (\ref{aspn eq:sin}).
The value of $\mu$ is 3.6 and the subdomains are $\Omega_1=(-1,0.2)$ and $\Omega_2=(-0.2,1)$.
\textbf{Middle:} $G(\gamma)$ and its Newton-Raphson acceleration.
\textbf{Right:} $G(\gamma)$ plotted with the geometry of the right of Figure \ref{aspn fig:borders}.
}
\label{aspn fig:ex1}
\end{figure}
The results of the Newton-Raphson acceleration are found in Figure \ref{aspn fig:ex1} (left).
While for most initial values of $\gamma$ the method converges to the correct solution $u=0$ there are two small intervals where the method enters a stable cycle.

The function $G(\gamma)$ can be plotted numerically, along with its Newton-Raphson acceleration, see Figure \ref{aspn fig:ex1} (middle), which shows that $G(\gamma)$ does indeed lie within region 2 as predicted by Theorem \ref{aspn thm:lui}.
However, $G(\gamma)$ runs tangential to one of the lines $g_C(\gamma)$, see Figure \ref{aspn fig:ex1} (right), and so its Newton-Raphson acceleration crosses into region 4.
Due to symmetry, there is a 2-cycle at each crossing.
Depending on the slope of the acceleration as it crosses into region 4 this cycle may be stable.

Where stable cycles exist so too must there be period doubling bifurcation.
Changing the value of the parameter $\mu$ we find that the 2-cycle found in Figure \ref{aspn fig:ex1} (left) becomes two 2-cycles, then two 4-cycles, and so on until it devolves into chaos, see Figure \ref{aspn fig:ex2}.
\begin{figure}
\centering
        \includegraphics[width=\textwidth]{FIG_ASPN/bifurcation_20220905.eps}
        \caption{Period doubling bifurcation in the example caused by Newton-Raphson acceleration.}
\label{aspn fig:ex2}
\end{figure}
With enough chaos the cycles are no longer stable and the acceleration exits into a convergent region.

% possible relationships between overlap and basin of cycling

While a change in the parameter $\mu$ is the most obvious way to alter the dynamics, one can also change the size of the overlap.
This has a direct effect on the basin of cycling in the spaces of both initial condition $\gamma$ and the parameter $\mu$.
\begin{figure}[t]
\centering
	\includegraphics[width=0.45\textwidth]{FIG_ASPN/MTLB_1Dsin_ParamOverlap_v1_20220905.eps}
	\includegraphics[width=0.45\textwidth]{FIG_ASPN/MTLB_1Dsin_BasinOverlap_v1_20210208.eps}
\caption{
\textbf{Left:} value of $\mu$ at which bifurcation starts.
\textbf{Right:} width of basin of cycling in $\gamma$ and $\mu$.}
\label{aspn fig:overlap}
\end{figure}
Figure \ref{aspn fig:overlap} (left) shows a nonlinear relationship between the first value of $\mu$ at which cycling is observed and the size of the overlap.
As the overlap grows the parameter $\mu$ must be larger and larger for cycling to occur.
Figure \ref{aspn fig:overlap} (right) indicates that the interval of initial conditions that result in cycling shrinks as the overlap grows.
Meanwhile, the length of the bifurcation diagram increases, meaning there are more values of $\mu$ with stable cycling.

\subsection{Alternating Schwarz and its fixed point iteration in higher dimensions}

Now consider a more general alternating Schwarz, again for a second order nonlinear differential equation but on a domain $\Omega \in \bbr^d$:
\begin{equation*}
\begin{cases} F(x,u_1^n, D u_1^n, D^2 u_1^n) = 0 & x \in \Omega_1 \\
u_1^n(x) = h(x) & x \in \partial \Omega \\
u_1^n(x) = u_2^{n-1}(x) & x \in \Gamma_1 \end{cases}
\begin{cases} F(x,u_2^n, D u_2^n, D^2 u_2^n) = 0 & x \in \Omega_2 \\
u_2^n(x) = h(x) & x \in \partial \Omega \\
u_2^n(x) = u_1^n(x) & x \in \Gamma_2, \end{cases}
\end{equation*}
where $\Gamma_1 = \partial \Omega_1 \setminus \partial \Omega$ and $\Gamma_2 = \partial \Omega_2 \setminus \partial \Omega$.
Note that $Du$ (and $D^2 u$) represents the collection of the partial derivatives (and second partial derivatives, including mixed derivatives) of the function $u(x)$.

As in the 1D case, one can construct the implicit function $G:L_2(\Gamma_1) \to L_2(\Gamma_1)$ using the following two steps:
\begin{equation*}
(1) \begin{cases} F(x,u_1,Du_1,D^2u_1) = 0 \\ u_1(\partial \Omega) = h \\ u_1(\Gamma_1) = \gamma \end{cases} \
(2) \begin{cases} F(x,u_2,Du_2,D^2u_2) = 0 \\ u_2(\partial \Omega) = h \\ u_2(\Gamma_2) = u_1(\Gamma_2) \end{cases}
\end{equation*}
so that $G(\gamma) = u_2(\Gamma_1)$.

We are now interested in modifying the third and fourth steps of the algorithm presented for 1D so that they may be applied to higher dimensions.
Let us focus on the discrete case, where $\gamma \in \bbr^N$ for some $N$.
Likewise in the discrete case $\Gamma_1 \in \bbr^N$ and $\Gamma_2 \in \bbr^M$.
Then $G(\gamma)$ is a vector field and $G'(\gamma) \in \bbr^{N \times N}$ for each $\gamma$.
As well, the derivative of $u_1$ with respect to $\gamma$ is now a Jacobian.

Let $g_1:\Omega_1 \to \bbr^N$ represent $\pdxdy{u_1}{\gamma}$.
Then the third step may be written as:
\begin{equation*}
(3) \begin{cases} J(u_1) \cdot g_1 = 0 \\
g_1(\partial \Omega) = 0 \\
g_1(\Gamma_1) = I_{N \times N} \end{cases}
\end{equation*}
where the last line signifies that the $i$--th entry of $g_1(x_j)$ is equal to $\delta_{i,j}$ (the Kronecker delta) for all $x_j \in \Gamma_1$.
The object to pass to the second subdomain, $g_1(\Gamma_2)$, is then a matrix with each column representing a value of $\Gamma_2$ and each row representing a derivative with respect to an element of $\gamma$.
Thus it is of size $N \times M$.

Using the same representation for the other domain, taking $g_2: \Omega_2 \to \bbr^M$ to be the derivative of $u_2$ with respect to $u_1(\Gamma_2)$, one may write the fourth step as:
\begin{equation*}
(4) \begin{cases} J(u_2) \cdot g_2 = 0 \\
g_2(\partial \Omega) = 0 \\
g_2(\Gamma_2) = I_{M \times M} . \end{cases}
\end{equation*}
Then $g_2(\Gamma_1) \in \bbr^{M \times N}$ and
$G'(\gamma) = g_1(\Gamma_2) g_2(\Gamma_1)$.
%One could instead take $g_2$ to be $\pdxdy{u_2}{\gamma}$ by replacing $I_{M \times M}$ with $g_1(\Gamma_2)$, so that $G'(\gamma) = g_2(\Gamma_1)$.

The fifth step is then standard high dimension Newton-Raphson:
\begin{align*}
(5) \quad \gamma_{n+1} & = \gamma_n - (G'(\gamma_n) - I)^{-1} (G(\gamma_n) - \gamma_n) \\
					   & = \gamma_n - (g_1(\Gamma_2) g_2(\Gamma_1) - I)^{-1} (u_2(\Gamma_1) - \gamma_n).
\end{align*}

Theorem \ref{aspn thm:mono} can be generalized to higher dimensions.

\begin{theorem}
If the problem
\begin{equation*}
	\begin{cases} F(u,Du,D^2u) = 0 & x \in \Omega \\ u(x) = h(x) & x \in \partial \Omega \end{cases}
\end{equation*}
is nonsingular on $\Omega \setminus \Omega_1$ and $\Omega \setminus \Omega_2$ in the sense that there exists a unique solution to the problem on those domains and the continuations of these solutions are also unique, then $G(\gamma)$ is injective.
\end{theorem}

\begin{proof}
The proof is identical to that for theorem \ref{aspn thm:mono} with all objects replaced by their higher dimension counterparts.
\end{proof}

If $G(\gamma)$ is also continuous (we require differentiable to use Newton's method) and it can be proven that alternating Schwarz converges unconditionally to a unique solution (ex. theorem 2 from \cite{lui1999schwarz}) then any starting point defines a path leading to the fixed point.
These paths do not intersect and $G(\gamma)$ is monotonic along each path, in the sense that if the path were parametrized by a variable $s$ then $\gamma(s_2) = G(\gamma(s_1))$ implies $s_2>s_1$.

% section on the algorithm

\section{Accelerated alternating Schwarz with guaranteed convergence}

Given Theorem \ref{aspn thm:lui} and the conditions of Table \ref{aspn tab:conditions} one can construct a series of tests to see if the Newton-Raphson acceleration is suitable for a given iteration.
We present one further useful trick to strengthen convergence, a correction to Newton-Raphson due to Davidenko and Branin \cite{branin1972widely,brent1972davidenko,davidenko1953new}.
We replace step (3) in the algorithm with
\begin{equation*}
(3*) \quad \tilde{\gamma}_n = \gamma_n - \frac{G(\gamma_n) - \gamma_n}{\abs{G'(\gamma_n) - 1}} .
\end{equation*}
For $G(\gamma)$ within region 2 the Newton-Raphson acceleration will now always march in the direction of the fixed point.
It may still overshoot and cycle but the direction will always be correct.

For a problem satisfying the conditions of Theorem \ref{aspn thm:lui} or similar that guarantees that $G(\gamma)$ lies in region 2 the algorithm proceeds as follows.
\begin{algorithm}
\begin{enumerate}
\item Select some $\gamma_0 \in \mathbb{R}$. Set $n=0$.
\item Calculate $G(\gamma_n)$ and $G'(\gamma_n)$.
If $G'(\gamma_n) = 1$ then set $\gamma_{n+1} = G(\gamma_n)$, increment $n$ and return to step 2.
If this is not true, proceed to step 3.
\item Perform step (3*), which is the Newton-Raphson acceleration using the Davidenko-Branin trick.
If $\abs{G'(\gamma_n) - 1} \geq 1/2$ then set $\gamma_{n+1} = \tilde{\gamma}_n$, increment $n$ and return to step 2.
If this is not true, calculate $\hat{\gamma}_n$, the average of $\gamma_n$ and $\tilde{\gamma}_n$, and proceed to step 4.
\item Calculate $G(\hat{\gamma}_n)$.
If $G(\hat{\gamma}_n)-\hat{\gamma}_n$ has the same sign as $G(\gamma_n) - \gamma_n$ then set $\gamma_{n+1} = \tilde{\gamma}_n$, increment $n$ and return to step 2.
If this is not true, set $\gamma_{n+1} = G(\gamma_n)$, increment $n$ and return to step 2.
\end{enumerate}
\end{algorithm}

Each of steps 2, 3 and 4 contain a test of whether Newton-Raphson will converge.
In step 2, Newton-Raphson will not converge if the derivative of $G(\gamma)-1$ is zero.
In step 3, convergence is guaranteed if $G'(\gamma) \leq 1/2$ based on Table \ref{aspn tab:conditions}.
The Davidenko-Branin trick strengthens this and also guarantees convergence if $G'(\gamma) \geq 3/2$.

In step 4 we test the point halfway between the starting value $\gamma_n$ and the Newton-Raphson acceleration $\tilde{\gamma}_n$, denoted $\hat{\gamma}_n$.
Since $G(\gamma)$ is in region 2 if $G(\gamma) > \gamma$ then $\gamma < \gamma^*$ and vice versa.
Therefore, we can easily determine whether $\hat{\gamma}_n$ is on the same side of the fixed point as $\gamma_n$.
If it is, then the fixed point $\gamma^*$ lies on the same side of $\hat{\gamma}_n$ as $\tilde{\gamma}_n$, and so $\tilde{\gamma}_n$ is closer to $\gamma^*$ than $\gamma_n$.
If it is not, then $\gamma^*$ lies between $\gamma_n$ and $\hat{\gamma}_n$.
Since $\tilde{\gamma}_n$ is on the other side of $\hat{\gamma}_n$ it is further from $\gamma^*$ than $\gamma_n$ and we have divergence.
In such a case, the fixed point iteration should be used.

Note that while $G(\gamma)$ represents alternating Schwarz in this context, it may be exchanged for any fixed point iteration, in particular any Schwarz method.
All that is required for the algorithm to function is for $G(\gamma)$ to be within region 2.
For Schwarz methods, this would necessitate a theorem similar to Theorem \ref{aspn thm:lui}.

\section{Finding the space of counterexamples}

We seek a larger space of examples where cycling occurs for ASPN.
To do so, we employ optimization techniques.
First we must find a functional that takes a nonlinearity and returns a measure of the chaos that results from applying ASPN.

We consider the set of problems
\begin{equation}
u''(x) + f(u(x)) = 0, \quad x \in (-1,1)
\end{equation}
with homogeneous Dirichlet boundary conditions.
The function $f(x)$ satsifies $f(0)=0$ so that $u(x)=0$ is the solution to the ODE.

The counterexample already presented makes use of the antisymmetry in $G(\gamma)$ to achieve its cycles.
We wish the same for all nonlinearities $f(x)$ in our space of counterexamples.

\begin{proposition} \label{aspn prop: antisymmetry}
If $f(x)$ is antisymmetric then $G(\gamma)$ is antisymmetric.
\end{proposition}

\begin{proof}
Suppose $\hat{u}_1(x)$ solves step (1) of alternating Schwarz with $u_1(\beta)=\gamma$.
Then $$-\hat{u}_1'' + f(-\hat{u}_1) = f(\hat{u}_1) - f(\hat{u}_1) = 0.$$
Thus, $-\hat{u}_1(x)$ solves step (1) of alternating Schwarz with $u_1(\beta)=-\gamma$.

By the same logic, if $\hat{u}_2(x)$ solves step (2) of alternating Schwarz with $u_2(\alpha) = u_1(\alpha)$ then
$-\hat{u}_2(x)$ solves step (2) with $u_2(\alpha) = -u_1(\alpha)$.
Thus, $-\hat{u}_2(\beta) = -G(\gamma) = G(-\gamma)$.
\end{proof}

We therefore restrict our search to nonlinearities which are antisymmetric.
It is then sufficient for the Newton-Raphson acceleration, represented by $G_N(\gamma)$, to cross the line $y=-\gamma$ for cycles to exist.

Given that $f(x)$ is antisymmetric it can be decomposed into a Fourier series consisting solely of sinusoids:
\begin{equation} \label{aspn eq: f sin}
f(x) = \sum_{k=1}^N c_k \sin(\pi k x).
\end{equation}
Thus, the functional to optimize takes a set $\set{c_k}_{k=1}^N \in \bbr^N$, passes it through $f(x) \in C(-1,1)$ and $G(\gamma) \in C(\bbr)$ to arrive at a measure for the chaos of the system.
We will represent this functional as $L: \bbr^N \to \bbr.$
There are many ways to define $L(\set{c_k})$, but we shall use
\begin{equation} \label{aspn eq: optsin}
L(\set{c_k}) := \norm{G_N(\gamma) + \gamma}.
\end{equation}
Thus, $L(\set{c_k}) = 0$ if and only if $G_N(\gamma)=-\gamma$, and ASPN cycles between $\gamma$ and $-\gamma$ for all values of $\gamma$.

It is well-known that there always exists a region around the root of a function where Newton-Raphson converges, assuming continuity of $G''(\gamma)$ and $G'(\gamma) \neq 1$.
We expect then to find only local minimizers of $L(\set{c_k})$.
We use a gradient descent with line search to optimize the functional $L$, with restrictions $\gamma \in [-2,2]$ and $\set{c_k}_{k=1}^5 \in \bbr^N$, with starting condition $c_1=1$, $c_i=0$ for $i=2, \dots, 5$.
There is an overlap of 0.4 between the domains, which are symmetric about $x=0$.
We find an exceptional counterexample using this methodology, as presented in Figure \ref{aspn fig: optsin example}.
\begin{figure}
\centering
\includegraphics[width=\textwidth]{FIG_ASPN/MTLB_optsin_f_v1_20220704.eps}
\caption{A counterexample found through optimizing the functional $L$, equation (\ref{aspn eq: optsin}).
	(Left) ASPN falls into a stable 2-cycle; the basin of attraction of this cycle is most values within $[-2,-1) \cup (1, 2]$.
	(Right) The function $f(x)$ for this counterexample; it is the sum of five sinusoids.}
\label{aspn fig: optsin example}
\end{figure}

We now seek counterexamples in 2D.
That is, we seek $f: \bbr \to \bbr$ such that using ASPN to solve
\begin{equation*}
u_{xx}(x,y) + u_{yy}(x,y) + f(u(x,y)) = 0, \quad x,y \in (-1,1)
\end{equation*}
with homogeneous Dirichlet boundary conditions results in cycling behaviour.
The two domains are split along the $x$-axis, so that the first domain is $x \in (-1,\alpha)$, $y \in (-1,1)$ and the second is $x \in (-\alpha,1)$, $y \in (-1,1)$.

As before, $f(x)$ is chosen to be antisymmetric so that $G(\vec{\gamma})$ is antisymmetric.
Proposition \ref{aspn prop: antisymmetry} applies to the higher dimensional case by replacing all relevant scalar objects ($\gamma$, $G(\gamma)$) with their corresponding vectors ($\vec{\gamma}$, $G(\vec{\gamma})$).
The decomposition of $f(x)$ into sinusoids and the definition of the functional $L(\set{c_k})$ remain unchanged.

If $\gamma$ is the discretization of a sinusoid then $G(\gamma)=c \gamma$, where $c \in \bbr$, up to numerical error.
This can be seen by transforming the solution into a Fourier series in the $y$ variable.
Suppose
\begin{equation*}
\begin{cases} \frac{\partial^2}{\partial x^2} u_{1}(x,y) +\frac{\partial^2}{\partial y^2} u_{1}(x,y) + f(u_1(x,y)) = 0, & x \in (-1,\alpha), \quad y \in (-1,1) \\
u_1(-1,y)=u_1(x,\pm 1) = 0 \\
u_1(\alpha,y) = C \sin(\pi m y) \end{cases}
\end{equation*}
where $f(x)$ is antisymmetric and can therefore be expressed in the form of equation (\ref{aspn eq: f sin}).
Use as an ansatz $u_1(x,y) = g(x) \sin (\pi m y)$.
Take the Fourier transform of the equation:
\begin{align*}
0 = & \int_{-1}^1 (g''(x) - m^2 \pi^2 g(x)) \sin(\pi m y) \sin(\pi k y) + f(g(x) \sin(\pi m y)) \sin (\pi k y) dy \\
= & (g''(x) - m^2 \pi^2 g(x) ) \delta_{m,k} C_m + \int_{-1}^1 \sum_{j=1}^N c_j \sin(\pi j g(x) \sin(\pi m y) ) \sin(\pi k y) dy \\
= & \delta_{m,k} \mathcal{L} g(x) + \sum_{j=1}^N c_j \int_{-1}^1 \sum_{n=0}^\infty \frac{(\pi j g(x))^{2n+1}}{(2n+1)!} \sin(\pi m y)^{2n+1} \sin(\pi k y) dy \\
= & \delta_{m,k} \mathcal{L} g(x) + \sum_{j=1}^N c_j \sum_{n=0}^\infty \frac{(\pi j g(x))^{2n+1}}{(2n+1)!} S(2n+1),
\end{align*}
where $S(n)$ is the integral of $\sin(\pi m y)^n \sin(\pi k y)$ over $(-1,1)$.
We can find a recursive formula for $S(2n+1)$:
\begin{align*}
S(2n+1) = & -\frac{1}{\pi k} \cos(\pi k y) \sin(\pi m y)^{2n+1} \bigg \vert_{-1}^1 \\
& + \int_{-1}^1 \frac{m}{k} (2n+1) \cos(\pi k y) \cos(\pi m y) \sin(\pi m y)^{2n} dy \\
= & (2n+1) \frac{m}{k} \bigg ( -\frac{1}{\pi k} \cos(\pi m y) \sin(\pi m y)^{2n} \sin(\pi k y) \bigg \vert_{-1}^1 \\
& + \frac{m}{k} 2n \int_{-1}^1 \sin(\pi k y) \left ( -\sin (\pi m y)^{2n+1} + \cos(m \pi y)^2 \sin (\pi m y)^{2n-1} \right ) dy \bigg ) \\
= & (2n+1) (2n) \frac{m^2}{k^2} \int_{-1}^1 \sin(\pi m y)^{2n-1} \sin(\pi k y) - 2 \sin(\pi m y)^{2n+1} \sin(\pi k y) dy \\
= & (2n+1) (2n) \frac{m^2}{k^2} \left ( S(2n-1) - 2 S(2n+1) \right ) \\
= & \frac{ (2n+1) (2n) \frac{m^2}{k^2} }{1 + 2 (2n+1) (2n) \frac{m^2}{k^2}} S(2n-1) \\
= & C(m,k,n) S(1) .
\end{align*}
The value of $S(1)$ is zero unless $k=m$.
This proves there exists a function $\tilde{f}_m(x)$ such that
\begin{equation*}
\mathcal{L} g(x) + \tilde{f}_m(g(x)) = 0 .
\end{equation*}
Thus, if $g(x)$ satisfies this ODE with boundary conditions $g(-1) = 0$ and $g(\alpha)=C$ then $u_1(x,y)$ solves the PDE.
Since $u_1(x,y)$ in this form satisfies the boundary conditions it is the unique solution to this step of alternating Schwarz.
The solution on the second domain, $u_2(x,y)$, then also has the same form by a symmetry argument, and its value at $x=-\alpha$ is a sinusoid of the same period.
Therefore, $G(\gamma) = c \gamma$.

As a direct consequence of this, starting with any single sine wave as boundary conditions provides a single parameter pathway for the function $G: \bbr^N \to \bbr^N$.
We take advantage of this fact and use $c \sin(\pi y)$ as the boundary condition for the first subdomain of ASPN, varying $c$ between -0.5 and 0.
To seed the optimization we use the previously obtained counterexample nonlinearity $f(x)$ from the 1D case.
The same optimization method is used.

\begin{figure}
\centering
\includegraphics[width=\textwidth]{FIG_ASPN/MTLB_optsin2D_f_v1_20220705.eps}
\caption{A chaotic ASPN sequence in 2D, at three resolutions (top row, bottom left).
	The nonlinearity (bottom right) is found through optimization on the functional $L$, equation (\ref{aspn eq: optsin}).
	The ASPN sequence is seeded using a sine wave $\sin(\pi y)$ as boundary condition on the first subdomain, but quickly diverges from this pathway.}
\label{aspn fig: optsin2d}
\end{figure}
The resulting nonlinearity does not admit a stable cycle but highlights the chaos that can result from using ASPN.
Figure \ref{aspn fig: optsin2d} gives this nonlinearity and an example of a sequence generated by ASPN.
The sequence begins on the sine wave path described previously.
It then approaches a nearby stable cycle, having departed from the strict sine wave path to one that closely resembles sine waves (bottom left of figure).
However, the cycle is not numerically stable and is ultimately abandoned.
As it leaves this pathway it descends into a divergent regime, with the norm growing exponentially (top left).
It quickly ejects onto a convergent pathway (top right).
It is possible these cycles exist on saddlepoints, stable along some pathways but unstable along others.
A small numerical error will then shunt the ASPN sequence away from the cycle, either to a divergent (top left) or convergent (top right) pathway.

Figure \ref{aspn fig: optsin2d iterates} provides snapshots of the solution at each of the iterates.
\begin{figure}
\centering
\includegraphics[trim={2.9cm 1.5cm 2.3cm 1.5cm},clip,width=\textwidth]{FIG_ASPN/MTLB_optsin2D_iterates_v1_20220727.eps}
\caption{The first 24 iterations of the chaotic ASPN sequence.
	The left figure of each iteration shows the overall solution at that step combined from the two subdomains, and the right of each shows the resulting $G(\gamma)$ in blue and the ASPN result in black.
	For comparison, the sine wave $0.5 \sin(\pi y)$ is plotted for the cycling regime, with sign that alternates with each iteration.}
\label{aspn fig: optsin2d iterates}
\end{figure}
The first 24 iterations of ASPN are shown, giving the nearly cycling regime (iterations 1 to 12), the divergent regime (13 to 20) and the convergent regime (21 to 24).
The cycling regime is very nearly a cycle of sine waves, as seen by the comparable sine waves in red.
A small change from these sine waves in iteration 13 causes chaos to take over until relative stability in iteration 20.
From there, ASPN converges quickly, arriving at the solution by iteration 24.
The remaining iterates resolve this solution to higher precision.

\section{Conclusions}

These results show that acceleration cannot be used without consequences for all Schwarz algorithms.
As with standard Newton-Raphson, there exist problems for which the sequence diverges, cycles or behaves chaotically.

In 1D, necessary and sufficient conditions for convergence could be found, assuming certain properties of the problem being solved.
Using these conditions as well as known tricks to stabilize Newton-Raphson, one can construct a convergent algorithm.
Higher dimensions proves more challenging, as more can go wrong.

Starting from a single counterexample we found many more through optimization of a functional which increases when the iterates become cyclical.
This work was extended into 2D, showing that adding dimensionality does not resolve the problem.